import torch
import torch.nn as nn

BATCH_SIZE = 4096
HIDDEN_DIM = 4096
SHAPE = (BATCH_SIZE, HIDDEN_DIM)

ALPHA_VAL = 1.0
BETA_VAL = 1.0
LAMBDA_VAL = 1.0

class TanhLU(nn.Module):
    """
    TanhLU Activation.
    https://www.sciencedirect.com/science/article/pii/S0957417422005681?via%3Dihub
    Formula: f(x) = alpha * tanh(lambda * x) + beta * x
    """
    def __init__(self, alpha=1.0, beta=1.0, lambda_p=1.0):
        super(TanhLU, self).__init__()
        self.alpha = alpha
        self.beta = beta
        self.lambda_p = lambda_p

    def forward(self, x: torch.Tensor) -> torch.Tensor:
        return self.alpha * torch.tanh(self.lambda_p * x) + self.beta * x

class Model(nn.Module):
    def __init__(self, alpha=1.0, beta=1.0, lambda_p=1.0):
        super(Model, self).__init__()
        self.act = TanhLU(alpha, beta, lambda_p)
    
    def forward(self, x):
        return self.act(x)

def get_inputs():
    input_tensor = torch.randn(SHAPE, dtype=torch.float32) * 5.0
    return [input_tensor.contiguous()]

def get_init_inputs():
    return [ALPHA_VAL, BETA_VAL, LAMBDA_VAL]